
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>


int main (int argc, char *argv[])
{
	int	finput, inputlen;
	struct	stat	inputstat;

	int	foutput;

	int	checksum;
	int	i, in_name, no;

	if (argc != 4) {
		fprintf (stderr, "Invalid numer of arguments!\n");
		return 1;
	}

	finput = open (argv[1], O_RDONLY);
	if (finput == -1) {
		fprintf (stderr, "Unable to open %s file!\n", argv[1]);
		return 1;
	}

	if (fstat(finput, &inputstat) == -1) {
		fprintf (stderr, "Can't stat %s file!\n", argv[1]);
		if (close (finput) == -1)
			fprintf (stderr, "Unable to close %s file!\n", argv[1]);
		return 1;
	}

	foutput = creat (argv[2], S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH);
	if (foutput == -1) {
		fprintf (stderr, "Unable to open %s file for writing!\n", argv[2]);
		return 1;
	}

	inputlen = inputstat.st_size;

	checksum = 0;

	no = 19;			/* header len */
	write (foutput, &no, 1);
	no = 0;
	write (foutput, &no, 1);
	checksum ^= no = 0;			/* type header */
	write (foutput, &no, 1);
	checksum ^= no = 3;
	write (foutput, &no, 1);

	in_name = 1;
	for (i = 4; i < 14; ++i) {			/* filename  */
		if (in_name && (argv[2][i-4] == '.' || argv[2][i-4] == '\0'))
			in_name = 0;
		if (in_name)
			checksum ^= no = argv[2][i-4];
		else
			checksum ^= no = ' ';
		write (foutput, &no, 1);
	}
	checksum ^= no = inputlen%256;		/* lenght */
	write (foutput, &no, 1);
	checksum ^= no = inputlen/256;
	write (foutput, &no, 1);
	checksum ^= no = atoi(argv[3])%256;	/* start address */
	write (foutput, &no, 1);
	checksum ^= no = atoi(argv[3])/256;
	write (foutput, &no, 1);
	checksum ^= no = 0;			/* param2 = 32768 */
	write (foutput, &no, 1);
	checksum ^= no = 128;
	write (foutput, &no, 1);
	no = checksum;
	write (foutput, &no, 1);

	checksum = 0;
	i = (inputlen + 2)%256;
	write (foutput, &i, 1);
	i = (inputlen + 2)/256;
	write (foutput, &i, 1);
	checksum ^= i = 255;
	write (foutput, &i, 1);
	while (read (finput, &i, 1)) {
		checksum ^= i;
		write (foutput, &i, 1);
	}
	i = checksum;
	write (foutput, &i, 1);
	

	if (close (foutput) == -1) {
		fprintf(stderr, "Unable to close %s file!\n", argv[2]);
		return 1;
	}

	if (close (finput) == -1) {
		fprintf (stderr, "Unable to close %s file!\n", argv[1]);
		return 1;
	}

	return 0;
}

